#
# awk-script for generating povray-scene from mcarlo output
#  by Joerg.Schulenburg(at)physik.uni-magdeburg.NOSPAMde
#
# see /usr/doc/info/gawk.info.gz
#
# version 1.0 Feb2000
#
#
  function outs( x, y, s, c){ # number  c=color s=number
  }
  BEGIN { nr=0; sc=1;  xl=yl=zl=0; xh=yh=zh=10; xm=ym=zm=5;
    printf "// spin state\n\n"\
      "#include \"colors.inc\"\n"\
      "camera {\n"\
      " location <2*sin(radians(360*clock)),0,4+1*cos(radians(360*clock))>\n"\
      " look_at  <0,0,0>\n"\
      " # angle 90\n up <0,1,0>\n"\
      "}\n"\
      "background { color rgb<.25,.25,.25> }\n"\
      "light_source { <10,30,50> color rgb<1,1,1> }\n\n"\
      "// bond textures\n"\
      "#declare text_b1 = texture {\n"\
      "   pigment { color rgbt<1.0,0.2,0.2,0.5> }\n"\
      "   finish { ambient 1 diffuse 0 }\n"\
      " }\n"\
      "// spin texture\n"\
      "#declare text_s1 = texture {\n"\
      "   pigment { color rgb<.0,.8,.8> }\n"\
      "   finish { ambient 0.8 diffuse 0.2 }\n"\
      " }\n"\
      "#declare text_s2 = texture {\n"\
      "   pigment { color rgb<.2,1,1> }\n"\
      "   finish { ambient 0.8 diffuse 0.2 }\n"\
      " }\n"\
    ;
   }
  /^\#/ { printf "// %s\n", $0 }
  /^box/ {	# x0, y0, z0,  x1, y1, z1
    xl=$2; yl=$3; zl=$4;
    xh=$5; yh=$6; zh=$7;
    xm=(xl+xh)/2.;
    ym=(yl+yh)/2.;
    zm=(zl+zh)/2.;
    printf "// box %g %g %g  %g %g %g  %g %g %g\n\n", xl,yl,zl,xh,yh,zh,xm,ym,zm
  }
  /^line/  {	# x0, y0, z0,  x1, y1, z1
     printf "cone { // line\n < %4g, %4g, %4g >, 0.05\n"\
                            " < %4g, %4g, %4g >, 0.05\n"\
            " texture { text_b1 }\n"\
            " }\n", \
       sc*($2-xm), sc*($3-ym), sc*($4-zm),\
       sc*($5-xm), sc*($6-ym), sc*($7-zm) ;
  }
  /^spin/  {    # x0, y0, z0,  rx, ry, rz,  num
     printf "union { // spin %2d\n"\
            " cone {\n"\
            "  < %4g, %4g, %4g >, 0.1\n"\
            "  < %4g, %4g, %4g >, 0.1\n"\
            "  texture { text_s1 }\n"\
            " }\n"\
            " cone {\n"\
            "  < %4g, %4g, %4g >, 0.2\n"\
            "  < %4g, %4g, %4g >, 0.0\n"\
            "  texture { text_s2 }\n"\
            " }\n}\n",  $8, \
       sc*($2-xm-.4*$5), sc*($3-ym-.4*$6), sc*($4-zm-.4*$7),\
       sc*($2-xm+.3*$5), sc*($3-ym+.3*$6), sc*($4-zm+.3*$7),\
       sc*($2-xm+.2*$5), sc*($3-ym+.2*$6), sc*($4-zm+.2*$7),\
       sc*($2-xm+.5*$5), sc*($3-ym+.5*$6), sc*($4-zm+.5*$7) ;
  }
